mode(-1);
lines(0);
tic()
mprintf('\n THIS IS AN UNIVARIATE EXAMPLE WITH GUI FACILITY \n');
mprintf("\n You can test/execute your own Univariate or Multivariate polynomial\n")
mprintf("\n Using exec command,execute [TOOLBOX_DIRECTORY_PATH>demos>Multivariate.sce] file. \n")
mprintf("\n To suppress source code comments, command must end with semicolon ; \n")
//*********************************************************************************************************************************************************************************************
//Sample Non-standard Example :
//'x+2*x*y+1',
//'-0.999e-12*f^3*h-0.127*f*g*i^4+13',
//'-x^4-3*x^3+x^2+2*x-1'
//'x^5+0.2*x^4+0.5*x^3+0.7*x^2-x; 
//'10*x^3-17*x^2+8*x+2' ;
//'-x^5+0.2*x^4+0.5*x^3+0.7*x^2-x';
//'x^6-52/25*x^5+39/80*x^4+71/10*x^3-79/20*x^2-x+1/10';
//'2.3*x^6+x^5+x^3-0.4*x+0.5'
//'x*y^2+x*z^2-1.1*x+1'; 
//x+2*y+10 x,y=[0,1]
//Sample Standard Example :
//
//Six Hump Back Camel Fun: 4*x^2-2.1*x^4+1/3*x^6+x*y-4*y^2+4*y^4 ; x,y=[-3,3] 
//Booth: 74-38*x+5*x^2-34*y+8*x*y+5*y^2; x,y=[-10,10]
//Caprasse's: -p*r^3+4*q*r^2*s+4*p*r*s^2+2*q*s^3+4*p*r+4*r^2-10*q*s-10*s^2+2 ;p,q,r,s=[-0.5,0.5]
//A neural network modeled by an adaptive Lotka-Volterra system:  p*q^2+p*r^2+p*s^2-1.1*p+1; p,q,r,s=[-2,2]
//System of A.H.,by Wright: t^2+p+q+r+s-t-10 ; p,q,r,s,t=[-5,5]
//A six variable magnetism in physics problem: 2*p^2+2*q^2+2*r^2+2*s^2+2*t^2+u^2-u ; p,q,r,s,t,u = [-0.5,0.5]
//Butcher1: u*q^2+t*r^2-p*s^2+s^3+s^2-1/3*p+4/3*s; p=[-1,0],q=[-0.1,0.9],r=[-0.1,0.5],s=[-1,-0.1],t=[-0.1,-0.05],u=[-0.1,-0.03]
//A seven variable problem of magnetism in physics: p^2+2*q^2+2*r^2+2*s^2+2*t^2+2*u^2+2*v^2-p ; p,q,r,s,t,u,v = [-0.5,0.5]
//A Eight variable heart dipole problem: -p*u^3+3*p*u*v^2-r*v^3+3*r*v*u^2-q*t^3+3*q*t*w^2-s*w^3+3*s*w*t^2-0.9563453 ; p=[-0.1,0.4],q=[0.4,1],r=[-0.7,-0.4],s=[-0.7,0.4],t=[0.1,0.2],u=[-0.1,0.2],v=[-0.3,1.1],w=[-1.1,-0.3]
//The 5-dimensional system of Reimer: -1+2*p^6-2*q^6+2*r^6-2*s^6+2*t^6 ;p,q,r,s,t=[-1,1]
//The 5-dimensional Hunecke :q^6*r+q*r^6+p^2*q^4*t-3*p*q^2*r^2*s*t+r^4*s^2*t-p^3*r*s*t^2-p*q*s^3*t^2+q*r*t^5 ;p=[0,1],q=[2,3],r=[-2,-1],s=[1,3],t=[-2,-1]
//The cyclic 5-roots problem: p*q*r*s+p*q*r*t+p*q*s*t+p*q*r*t+p*r*s*t+q*r*s*t; p,q,r,s,t=[-10,10]
//A six variable problem of magnetism in physics: 2*p^2+2*q^2+2*r^2+2*s^2+2*t^2+u^2-u ; p,q,r,s,t,u=[-5,5]
//(Six Variable) Hairer: r^3*s+q^3*t+p^3*u-0.25 ; p,q,r=[2,5],s,t,u=[-5,-2]
//(Six Variable)Camera displacement between two positions: -6.8*p*s-3.2*p*t+1.3*p*u+5.1*p-3.2*r*s-4.8*q*t-0.7*q*u-7.1*q+1.3*r*s-0.7*r*t+9.0*r*u-r+5.1*s-7.1*t-u+2.6 ; p,q,r,s,t,u = [-100, 100] 
//
//How to Plot above examples? For that, please refer this: 
//Using dot operator:
//x=-1:0.1:1;f1=-x.^4-3*x.^3+x.^2+2.*x-1;plot(x,f1);
//x=-2:0.1:11,f=x.^6-52/25.*x^5+39/80.*x^4+71/10.*x^3-79/20.*x^2.-x+1/10;plot(x,f)
//*********************************************************************************************************************************************************************************************
disp('..................'); 
f1=x_dialog('Enter Polynomial in the simplified format.( Use alphbetes between f to z and signs +,-,/,* and ^ Example: x+y*z-2*x^2+9999/9999)','x+2*y+10  ')
  while(f1==[] | f1==0),
   f1=x_dialog('Re-Enter Correct Polynomial','x+y*z-2*x^2+9999/9999     ')
end, 
mprintf('\n Entered Polynomial ');
disp(f1);
var=evstr(x_dialog('Number of Variable ?','2'))
  while(var==[] | var==0),
     var=evstr(x_dialog('Re-Enter Correct Number of Variables ?','1'));
  end,   
mprintf('\n Number of Variable ');
disp(var);
ActSubD=evstr(x_dialog('Number of Iterations ?(Recommended that,start with the current value 250)','250'))
ActSubD1=ActSubD;
mprintf('\n Number of Iterations ');
disp(ActSubD);
XB=zeros(var,2);   //[0 1; 0 1; 0 1;0 1];
XB=evstr(x_matrix('Enter Bounds to respective variables: Lower Bound | Upper Bound. Both should not be zero. ',XB))
  while(XB==[] | XB==0),
     XB=evstr(x_matrix('Both should not be zero. Re-Enter Correct Bounds to respective variables ',XB))
  end, 
mprintf('\n Entered Bounds to respective variables ');
disp(XB);
ex1=evstr(x_dialog('Enter Tolerance on Global minimizers/bounds i.e. Lsol','0.000001'))
                                // Tolerance on minimizers/box/bounds
  while(ex1==[] | ex1==0),
     ex1=evstr(x_dialog('Enter Tolerance on Global minimizers/bounds i.e. Lsol','0.000001'))
  end, 
mprintf('\n Entered Tolerance on Global minimizers/bounds ');
disp(ex1);
ex=evstr(x_dialog('Enter Tolerance on Global minimum i.e. zcap','0.000001'))
                                   // Tolerance on minimum
  while(ex==[] | ex==0),
     ex=evstr(x_dialog('Enter Tolerance on Global minimum i.e. zcap','0.000001'))
  end,
mprintf('\n Entered Tolerance on Global minimum ');
disp(ex);
disp('..................'); 
zcap=[];
XX=XB;
warning('off');
v=ascii(f1);
v(v==42)=[];                          
v1=v;

global LXsol,zcap

LXsol=[];
LXsol=cell(500,1);     
disp('Please wait for result ... ');
disp('Result ending with [ans =    ] .');
disp('..................');                                      // Initilization
var_array=unique(v(v>=102 & v<=122)); 
var_array(var_array=0)=[];
l=length(var_array);                 
dim=l;
dummy1=find(v==43);
dummy2=find(v==45);
dummy2((dummy2)==1)=[]; 
a=dummy2-1;
if a>=1 then,
dummy2=dummy2(v(a)~=101);
end,
dummy=gsort((cat(2,dummy1,dummy2)),'g','i');
if(isempty(dummy)) then,
  dummy1=length(v1);
else
  dummy1=dummy(1);                //Elements in term
end,
terms=length(dummy)+1;            // No. of terms into the polynomial
coeff1=cell(1,terms);             // Variables coeffs. list
[a,b]=size(var_array);
power1=zeros(a,b);                // Temporary variables powers list
power2=cell(1,terms);             // Variables powers list
                                  //Main loop    
if dummy=0 then   
   coeff1(1).entries=strtod(char(v(1:length(v)))); 
else
    for i=1:terms, 
        if i<terms then, 
           g1=find(v1>=102 & v1<=122)-1;
           zz=v1(1:g1(1));
            if (isempty(zz(1)) | ((zz(1)==43)& g1(1)<2)) then,   //(zz(1)==43)
             coeff1(i).entries=1; 
            elseif zz(1)==45 & g1(1)<2 then,
             coeff1(i).entries=-1;                       
            else 
             coeff1(i).entries=strtod(char(zz)); 
            end,              
             t1=0;
           if g1(1)>=1 then
              temp2=v1(1:g1(1));              
              t1=find(temp2==47);
              if t1>=1 then,
                coeff1(i).entries=strtod(char(temp2));
                for j=1:length(t1),
                 div=temp2(t1(j)+1:length(temp2));
                end,
                coeff1(i).entries=coeff1(i).entries/strtod(char(div));
               end,
              t1=0;

             end 
              g1=find(v1>=102 & v1<=122);
              temp2=v1(g1(1):dummy1(1));
              t1=find(temp2==94);
              for j=1:length(t1),
                  if length(t1)=1 | j=length(t1) then
                     pow(j).entries=temp2(t1(j)+1:length(temp2));   
                  else
                     pow(j).entries=temp2(t1(j)+1:t1(j+1)); 
                  end,
                     pow(j).entries=strtod(char(pow(j).entries(pow(j).entries>=48 & pow(j).entries<=57)));     
                     a=t1(j)-1;
                     if a>=1 then
                      power1((temp2(a)==var_array))=pow(j).entries;
                     end,
                 end,   
              temp3=gsort(temp2,'g','i');
              temp=find(temp3>=102 & temp3<=122);
              for j=1:length(temp), 
                  t=find(temp3(temp(j))==var_array);
                  if power1(t)=0 & (temp3(temp(j))==var_array(t)) then
                     power1(t)=1;
                  end,
              end         
              power2(i).entries=power1;
              [a,b]=size(var_array);
              power1=zeros(a,b);     // Variables powers list                
       elseif mtlb_any(v1(1:$)>=102 & v1(1:$)<=122) then,
                g1=find(v1>=102 & v1<=122)-1;
                zz=v1(1:g1(1));           
                if (isempty(zz(1)) | ((zz(1)==43)& g1(1)<2)) then,
                   coeff1(i).entries=1;          
                elseif zz(1)==45 & g1(1)<2 then,
                   coeff1(i).entries=-1;               
                else
                   coeff1(i).entries=strtod(char(zz));    
                end,                         
                t1=0;
              if g1(1)>=1 then
                temp2=v1(1:g1(1));                 
                t1=find(temp2==47);
               if t1>=1 then,
                 coeff1(i).entries=strtod(char(temp2));
                for j=1:length(t1),
                 div=temp2(t1(j)+1:length(temp2));
                end,
               coeff1(i).entries=coeff1(i).entries/strtod(char(div));
              end,
              t1=0;
            
             end, 
                g1=find(v1>=102 & v1<=122);
                temp2=v1(g1(1):dummy1(1));
                 t1=find(temp2==94);
                for j=1:length(t1),
                    if length(t1)=1 | j=length(t1) then
                       pow(j).entries=temp2(t1(j)+1:length(temp2));   
                    else
                       pow(j).entries=temp2(t1(j)+1:t1(j+1)); 
                  end,  
                    pow(j).entries=strtod(char(pow(j).entries(pow(j).entries>=48 & pow(j).entries<=57)));     
                    a=t1(j)-1;
                    if a>=1 then
                     power1((temp2(a)==var_array))=pow(j).entries;
                    end,
                 end   
                temp3=gsort(temp2,'g','i');
                temp=find(temp3>=102 & temp3<=122);
                for j=1:length(temp), 
                    t=find(temp3(temp(j))==var_array);
                    if power1(t)=0 & (temp3(temp(j))==var_array(t)) then
                       power1(t)=1;
                    end,
                end               
              power2(i).entries=power1;
              [a,b]=size(var_array);
              power1=zeros(a,b);            // Variables powers list     
         else         
              temp2=v1(1:length(v1));
              t1=0;
              coeff1(i).entries=strtod(char(temp2));
              t1=find(temp2==47);
              if t1>=1 then
                for j=1:length(t1),
                 div=temp2(t1(j)+1:length(temp2));
                end,
               coeff1(i).entries=coeff1(i).entries/strtod(char(div));
              end,
              t1=0;
              [a,b]=size(var_array);
              power2(i).entries=zeros(a,b);     // Variables powers list
         end,  //if i<terms... loop ending
           if i~=terms then
              v1=v(dummy(i):$);
               dummy1=gsort([find(v1==43) find(v1==45)],'g','i');
               dummy1(dummy1(1)==1)=[];
               b=dummy1-1;
               if b>=1 then                
                 dummy1=dummy1(v1(b)~=101);
               end,
               dummy1(isempty(dummy1))=length(v1);
           end,
    end                                       // for i:terms... loop ending
 end                                          // if dummy=0... loop ending 
// Forming the patch of coeffs. and powers          
patch1=cat(2,cell2mat(coeff1'),cell2mat(power2(:)));
[c d]=size(patch1);
c=c*d;
patch2=matrix(patch1',c,1);
a1=patch2;
ncoeff=terms;
count=1;
k=matrix(patch2(count:count+ncoeff*(dim+1)-1),dim+1,ncoeff)';
count=count+ncoeff*(dim+1);
N=mtlb_max(k(:,2:$),[],1);
    if dim==1 then,
        tel=zeros(N+1,1);
    else
        tel=mtlb_zeros(N+1);
    end,
    for i=1:ncoeff,
        coeff2=k(i,1);
        coeff_power=k(i,2:$);
         //converting index to linear index...% poly mat dim is one more than coeff dim
        sub=coeff_power+1;
        siz=N+1;
        k1=[1 cumprod(siz(1:$-1))];
        sub=sub-1;
        index=mtlb_sum(sub.*k1)+1;       
        tel(index) =tel(index) + coeff2;
    end
         A=tel;                                   // Multivariate Coefficient Matrix
        [M,N,B] = InvUVW(A,XB);
                                                 //Calculation for M
M=M;
B=B;
zcap=max(B(:));

Boxes=1;                                        // No. of sub boxes
ActSubD=450;                                    //No. of Subdivision has to complete
SubD=0;
flag=0;LX=0;LB=0;D1=0;Z1=0;Y=0;X0=0;V=0;XV=0;
////Maximum width property

LB(1,1).entries=B(:);                          // otherwise gives an error 999. maxi:wrong type for Argument 1
LB(1,1).entries=B;
LX(1,1).entries=XB;
id=1;
k2=1;
while(id),
  if SubD==ActSubD then,
    ActSubD=evstr(x_matrix('You have exceeds given No. of Iterations.Press OK with new entry or put 0(zero) to stop ?',ActSubD))
    ActSubD=ActSubD1+ActSubD;
  end,  
  if SubD>ActSubD then,
    break;
   end, 
   B=LB(1,id).entries;
   X=LX(1,id).entries;                                 
  id=id-1;
  [valid1,valid2,B1,B2,X1,X2,SubD,Bmin1,Bmin2,zcap,LXsol,Boxes,flag,D1,Z1,Y,X0,V,XV]=loop(B,X,A,ex1,zcap,N,Boxes,LXsol,D1,Z1,Y,flag);
   if (valid1==1 & valid2==1) then,
       id=id+2;
       if (Bmin1>Bmin2) then,        
         LB(1,id).entries=B2;
         LX(1,id).entries=X2;
         LB(1,id-1).entries=B1;
         LX(1,id-1).entries=X1;
       else
         LB(1,id).entries=B1;
         LX(1,id).entries=X1;
         LB(1,id-1).entries=B2;
         LX(1,id-1).entries=X2;
       end,  
  elseif valid1==1 then, 
     id=id+1;
     LB(1,id).entries=B1;
     LX(1,id).entries=X1;
  elseif valid2==1 then,
     id=id+1;  
     LB(1,id).entries=B2;     
     LX(1,id).entries=X2;
  end,  //if (valid1==1 & valid2==1)
 end, // for j=1:ActSubD while(id)

[zcap,temp,Lsol,D1,temp1,ss,Lsol1,trial]=finalresult(D1,ex1,ex,zcap,LXsol);  
zcap
Lsol
disp("Global Minimum zcap");
disp(zcap);
disp("Global Minimizers Lsol");
disp(Lsol);
filename = "Multivariate.sce";
dname = get_absolute_file_path(filename);
editor ( dname + filename );
toc()



 

